# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetProfilesProfilesResult',
    'AwaitableGetProfilesProfilesResult',
    'get_profiles_profiles',
    'get_profiles_profiles_output',
]

@pulumi.output_type
class GetProfilesProfilesResult:
    """
    A collection of values returned by getProfilesProfiles.
    """
    def __init__(__self__, id=None, profiles=None, region=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if profiles and not isinstance(profiles, list):
            raise TypeError("Expected argument 'profiles' to be a list")
        pulumi.set(__self__, "profiles", profiles)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def profiles(self) -> Sequence['outputs.GetProfilesProfilesProfileResult']:
        """
        List of Profiles.
        """
        return pulumi.get(self, "profiles")

    @property
    @pulumi.getter
    def region(self) -> builtins.str:
        return pulumi.get(self, "region")


class AwaitableGetProfilesProfilesResult(GetProfilesProfilesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetProfilesProfilesResult(
            id=self.id,
            profiles=self.profiles,
            region=self.region)


def get_profiles_profiles(region: Optional[builtins.str] = None,
                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetProfilesProfilesResult:
    """
    Data source for managing an AWS Route 53 Profiles.

    ## Example Usage

    ### Basic Usage

    ```python
    import pulumi
    import pulumi_aws as aws

    example = aws.route53.get_profiles_profiles()
    ```


    :param builtins.str region: Region where this resource will be [managed](https://docs.aws.amazon.com/general/latest/gr/rande.html#regional-endpoints). Defaults to the Region set in the provider configuration.
    """
    __args__ = dict()
    __args__['region'] = region
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('aws:route53/getProfilesProfiles:getProfilesProfiles', __args__, opts=opts, typ=GetProfilesProfilesResult).value

    return AwaitableGetProfilesProfilesResult(
        id=pulumi.get(__ret__, 'id'),
        profiles=pulumi.get(__ret__, 'profiles'),
        region=pulumi.get(__ret__, 'region'))
def get_profiles_profiles_output(region: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                 opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetProfilesProfilesResult]:
    """
    Data source for managing an AWS Route 53 Profiles.

    ## Example Usage

    ### Basic Usage

    ```python
    import pulumi
    import pulumi_aws as aws

    example = aws.route53.get_profiles_profiles()
    ```


    :param builtins.str region: Region where this resource will be [managed](https://docs.aws.amazon.com/general/latest/gr/rande.html#regional-endpoints). Defaults to the Region set in the provider configuration.
    """
    __args__ = dict()
    __args__['region'] = region
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('aws:route53/getProfilesProfiles:getProfilesProfiles', __args__, opts=opts, typ=GetProfilesProfilesResult)
    return __ret__.apply(lambda __response__: GetProfilesProfilesResult(
        id=pulumi.get(__response__, 'id'),
        profiles=pulumi.get(__response__, 'profiles'),
        region=pulumi.get(__response__, 'region')))
